/* $Header: config.h,v 3.1 98/08/13 17:17:58 carl Exp $ */

/************************************************************************
 * Copyright (c) 1998 The Trustees of Princeton University.
 * All rights reserved.
 * 
 * PRINCETON UNIVERSITY MAKES NO REPRESENTATIONS ABOUT THE SUITABILITY OF
 * THIS SOFTWARE FOR ANY PURPOSE.  IT IS PROVIDED "AS IS" WITHOUT EXPRESS
 * OR IMPLIED WARRANTY.  PRINCETON UNIVERSITY SHALL NOT BE LIABLE FOR ANY
 * DAMAGES SUFFERED BY THE USERS OF THIS SOFTWARE.
 ************************************************************************/


#ifndef _CONFIG_INCLUDED
#define _CONFIG_INCLUDED

#include "minopt_config.h"

/* Relational operators */
#define LTN -2     /* strictly less than */
#define LEQ -1     /* less than or equal to */
#define EQL  0     /* equal to */
#define GEQ  1     /* greater than or equal to */
#define GTN  2     /* strictly greater than */
#define OBJ  3     /* objective */

/* Solution status for the different solutions */
#define OPTIMAL       1
#define INFEASIBLE    2
#define UNBOUNDED     3
#define MAXIT_FEAS    4
#define MAXIT_INFEAS  5
#define STUCK         6
#define SOLVER_ERROR  9
#define NO_SOLVER     10
#define NO_INIT_POINT 15

/* MINLP solution status */
#define MINLP_OPTIMAL       401
#define MINLP_INFEASIBLE    402
#define MINLP_UNBOUNDED     403
#define MINLP_MAXIT_FEAS    404
#define MINLP_MAXIT_INFEAS  405
#define MINLP_STUCK         406
#define MINLP_SOLVER_ERROR  409
#define MINLP_OPTIMAL_MASTER_INFEASIBLE 410
#define MINLP_IPRIMAL_INFEAS 411
#define MINLP_ABORT_PRIMAL  412
#define MINLP_ABORT_MASTER  413
#define MINLP_INPUT_ERROR   414
#define MINLP_NO_INIT_POINT 415

/* dynamic solution status */
#define DYNAMIC_OK 501
#define DYNAMIC_BOUNDS_VIOLATION 502
#define DYNAMIC_SOLVER_ERROR 509
#endif /* CONFIG_INCLUDED */

