/* $Header: solver_proto.h,v 3.2 98/08/13 17:18:28 carl Exp $ */

/************************************************************************
 * Copyright (c) 1998 The Trustees of Princeton University.
 * All rights reserved.
 * 
 * PRINCETON UNIVERSITY MAKES NO REPRESENTATIONS ABOUT THE SUITABILITY OF
 * THIS SOFTWARE FOR ANY PURPOSE.  IT IS PROVIDED "AS IS" WITHOUT EXPRESS
 * OR IMPLIED WARRANTY.  PRINCETON UNIVERSITY SHALL NOT BE LIABLE FOR ANY
 * DAMAGES SUFFERED BY THE USERS OF THIS SOFTWARE.
 ************************************************************************/


#ifndef _SOLVER_PROTO_INCLUDED
#define _SOLVER_PROTO_INCLUDED

#include "minopt.h"
#include "solutions.h"

#if defined(__STDC__) || defined(__cplusplus)
# define P_(s) s
#else
# define P_(s) ()
#endif

/* Prototypes taken from cplex_proto.h--these must be the same!!!*/

/* gbd_master_cplex.c */
MASSOLTYPE gbd_master_cplex P_((PROBLEMTYPE p, int niter, PRISOLTYPE psol));

/* oaer_master_cplex.c */
MASSOLTYPE oaer_master_cplex P_((PROBLEMTYPE p, int niter, PRISOLTYPE psol));

/* oaerap_master_cplex.c */
MASSOLTYPE oaerap_master_cplex P_((PROBLEMTYPE p, int niter, PRISOLTYPE psol));

/* primal_cplex.c */
PRISOLTYPE primal_cplex P_((PROBLEMTYPE p, int niter, double *xstp, double *yk));

/* iprimal_cplex.c */
PRISOLTYPE iprimal_cplex P_((PROBLEMTYPE p, int niter, double *xstp, double *yk));

/* iprimal2_cplex.c */
PRISOLTYPE iprimal2_cplex P_((PROBLEMTYPE p, int niter, double *xstp, double *yk));


/* primal_lpsolve.c */
PRISOLTYPE primal_lpsolve P_((PROBLEMTYPE p, int niter, double *xstp, double *yk));

/* iprimal_lpsolve.c */
PRISOLTYPE iprimal_lpsolve P_((PROBLEMTYPE p, int niter, double *xstp, double *yk));

/* iprimal2_lpsolve.c */
PRISOLTYPE iprimal2_lpsolve P_((PROBLEMTYPE p, int niter, double *xstp, double *yk));

/* gbd_master_lpsolve.c */
MASSOLTYPE gbd_master_lpsolve P_((PROBLEMTYPE p, int niter, PRISOLTYPE psol));

/* oaer_master_lpsolve.c */
MASSOLTYPE oaer_master_lpsolve P_((PROBLEMTYPE p, int niter, PRISOLTYPE psol));

/* oaerap_master_lpsolve.c */
MASSOLTYPE oaerap_master_lpsolve P_((PROBLEMTYPE p, int niter, PRISOLTYPE psol));

/* primal_minossnopt.c */
PRISOLTYPE primal_minossnopt P_((PROBLEMTYPE problem, int niter, double *xstp, double *yk));

/* iprimal_minossnopt.c */
PRISOLTYPE iprimal_minossnopt P_((PROBLEMTYPE problem, int niter, double *xstp, double *yk));

/* iprimal2_minossnopt.c */
PRISOLTYPE iprimal2_minossnopt P_((PROBLEMTYPE problem, int niter, double *xstp, double *yk));

/* relax_minossnopt.c */
PRISOLTYPE relax_minossnopt P_((PROBLEMTYPE p, int niter, double *xstp, double *ystp));

/* primal_npsol.c */
PRISOLTYPE primal_npsol P_((PROBLEMTYPE problem, int niter, double *xstp, double *yk));

/* iprimal_npsol.c */
PRISOLTYPE iprimal_npsol P_((PROBLEMTYPE problem, int niter, double *xstp, double *yk));

/* iprimal2_npsol.c */
PRISOLTYPE iprimal2_npsol P_((PROBLEMTYPE p, int niter, double *xstp, double *yk));

/* relax_npsol.c */
PRISOLTYPE relax_npsol P_((PROBLEMTYPE p, int niter, double *xstp, double *ystp));

/* gbd_master_npsol.c */
MASSOLTYPE gbd_master_npsol P_((PROBLEMTYPE p, int niter, PRISOLTYPE psol));

/* dynamic_dasolv.c */
DYNSOLTYPE dynamic_dasolv P_((PROBLEMTYPE p, double *x, int npoints, double *time, int sens));

/* adjoint_dasolv.c */
DYNSOLTYPE adjoint_dasolv P_((PROBLEMTYPE p, DYNSOLTYPE dynsol, double *lambda, int npoints, double *time));

/* dynamic_daspkso.c */
DYNSOLTYPE dynamic_daspkso P_((PROBLEMTYPE p, double *x, int npoints, double *time, int sens));

/* adjoint_daspkso.c */
DYNSOLTYPE adjoint_daspkso P_((PROBLEMTYPE p, DYNSOLTYPE dynsol, double *lambda, int npoints, double *time));

/* dynamic_daessa.c */
DYNSOLTYPE dynamic_daessa P_((PROBLEMTYPE p, double *x, int npoints, double *time, int sens));

/* adjoint_daessa.c */
DYNSOLTYPE adjoint_daessa P_((PROBLEMTYPE p, DYNSOLTYPE dynsol, double *lambda, int npoints, double *time));

/* gbd.c */
OPTSOLTYPE gbd_solve P_((PROBLEMTYPE p, double *xstp, double *yk));

/* oaer.c */
OPTSOLTYPE oaer_solve P_((PROBLEMTYPE p, double *xstp, double *yk));

/* oaerap.c */
OPTSOLTYPE oaerap_solve P_((PROBLEMTYPE p, double *xstp, double *yk));

#undef P_

#endif /* _SOLVER_PROTO_INCLUDED */
