/* $Header: chemkin.c,v 3.4 98/09/03 13:28:08 carl Exp $ */

/************************************************************************
 * Copyright (c) 1998 The Trustees of Princeton University.
 * All rights reserved.
 * 
 * PRINCETON UNIVERSITY MAKES NO REPRESENTATIONS ABOUT THE SUITABILITY OF
 * THIS SOFTWARE FOR ANY PURPOSE.  IT IS PROVIDED "AS IS" WITHOUT EXPRESS
 * OR IMPLIED WARRANTY.  PRINCETON UNIVERSITY SHALL NOT BE LIABLE FOR ANY
 * DAMAGES SUFFERED BY THE USERS OF THIS SOFTWARE.
 ************************************************************************/


#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "chemkin.h"

#ifdef CHEMKIN
int parser_chemkin_init(char *filename)
{
  return chemkin_init(filename);
}

void parser_chemkin_close()
{
  chemkin_close();
}
#else
int parser_chemkin_init(char *filename)
{
  fprintf(stderr,"This version of MINOPT not compiled with chemkin");
  return 1;
}
void parser_chemkin_close()
{
}
#endif

static struct ckfun_node {
  char *name;       /* name of the function */
  ckfuntype fun; /* pointer to function */
} ckfun_tab[] = {
#ifdef CHEMKIN
  "ckarra", ck_arr_a,
  "ckarrb", ck_arr_b,
  "ckarre", ck_arr_e,
  "cknu", ck_nu,
  "cknuf", ck_nuf,
  "cknur", ck_nur,
  "cksmolar", ck_molar_entropy,
  "ckhmolar", ck_molar_enthalpy,
  "ckathm", ck_cp_coefficients,
  "ckrev", ck_reversible,
  "ckthb", ck_thirdbody,
  "ckwt", ck_molecularwt,
#endif /* CHEMKIN */
  NULL, NULL};

ckfuntype getckfun(char *name)
{
  int i;
  for(i=0;ckfun_tab[i].fun;i++)
    if(!strcmp(name,ckfun_tab[i].name))
      return ckfun_tab[i].fun;
  fprintf(stderr,"CHEMKIN Parameter Function %s not found\n",name);
  return NULL;
}
